(function() {
  "use strict";

  Snake.Logging = _.extend(Snake.Logging || {}, {
    Level: {
      none: 0,
      error: 1,
      warn: 2,
      log: 3,
      debug: 4
    },
    write: function(action, module, message) {
      if (_.isUndefined(Snake.Config.Logging[module])) {
        throw new Error("Can't find module \"" + module + "\"");
      }
      if (Snake.Config.Logging[module] >= Snake.Logging.Level[action]) {
        console[action]("[" + module + "] " + message);
      }
    },
    log: function() {
      Snake.Logging.write.apply(this,
          ["log"].concat(Array.prototype.slice.call(arguments)));
    },
    debug: function() {
      Snake.Logging.write.apply(this,
          ["debug"].concat(Array.prototype.slice.call(arguments)));
    },
    error: function() {
      Snake.Logging.write.apply(this,
          ["error"].concat(Array.prototype.slice.call(arguments)));
    },
    warn: function() {
      Snake.Logging.write.apply(this,
          ["warn"].concat(Array.prototype.slice.call(arguments)));
    },
    stringify: function(object) {
      return JSON.stringify(object, function (key, value) {
        if (value instanceof Uint8Array) return util.abv2hex(value);
        return value;
      }, "\t");
    }
  });

}());
