// Special thanks to the follwing people for their support to this project:
//
// * Gregor Zolynski
// * Ian Horswill
//

// DOM Ready
$(function() {
  "use strict";
  var pageModel, pageView, pinnedPages, loginView, registerView;

  // Initialize components
  Snake.Config.init();
  Snake.Schema.init();
  Snake.Network.init();
  Snake.IO.init();
  Snake.Modal.init();
  Snake.Crypto.init();
  Snake.View.init();

  pageModel = new Snake.Model.Page();

  loginView = new Snake.View.Login({
    el: $("#login-form")[0]
  }).render();
  registerView = new Snake.View.Register({
    el: $("#register-form")[0]
  }).render();

  loginView.on("logged", function() {
    // Hides the login and register forms and shows the main page
    $("#prelogin").toggleClass("hide");
    $("#page").toggleClass("hide");

    pinnedPages = {
      "stream": "Stream"
    };

    _(Snake.sessionUser.profiles.models).each(function(profile) {
      pinnedPages["profile/" + profile.id] =
          "My profile (" + profile.get("name") + ")";
    });

    pageView = new Snake.View.Page({
      model: pageModel,
      el: $("#content")[0],
      pinnedPages: pinnedPages
    });
    pageView.renderMenu();

    // TODO: find a more elegant solution
    // Initialize routing
    new Snake.Router({
      model: pageModel,
      view: pageView
    });
    Backbone.history.start();

    // Immediately look for new messages
    Snake.sessionUser.processNewMessages();

    // TODO: find a better place to register global functions
    $("#check-messages").click(function(event) {
      event.preventDefault();
      Snake.sessionUser.processNewMessages();
    });
  });
});
