(function() {
  "use strict";

  _.mixin({
    findByField: function(list, value, field) {
      var result;
      field = field || "id";
      result = _(list).filter(function(item) {
        if (item[field] instanceof Uint8Array) {
          return util.memcmp(item[field], value);
        } else {
          return item[field] === value;
        }
      }.bind(this));

      switch (result.length) {
        case 0:
          return undefined;
        case 1:
          return result[0];
        default:
          throw new Error("More than one match, while zero or one expected.");
      }
    },
// TODO: This function does not work with lodash underscore
//        mergeAll: function () {
//            // Append to arguments a function to join arrays
//            [].push.apply(arguments, function(a, b) {
//                return _.isArray(a) ? a.concat(b) : undefined;
//            });
//            return _.merge.apply(this, arguments);
//        },
    wrapAppend: function(value, appended) {
      return _(value).wrap(function() {
        // Save the first argument and delete it
        var oldFunction = arguments[0];
        [].shift.apply(arguments);

        // Call oldFunction, if defined
        if (!_(oldFunction).isUndefined()) {
          oldFunction.apply(this, arguments);
        }

        // Call the new function
        appended.apply(this, arguments);
      }.bind(this));
    },
    deepClone: function(obj) {
      if (obj instanceof Array) return obj.map(_.deepClone);
      return $.extend(true, {}, obj);
    },
    keyOf: function(obj, target) {
      var fkey = null;
      if (obj !== null) {
        _.any(obj, function(value, key) {
          if (value === target) {
            fkey = key;
            return true;
          }
          return false;
        });
      }
      return fkey;
    },
    filterUndefined: function(collection, thisArg) {
      var result;
      if (_(collection).isArray()) {
        return _.filter(collection, function(a) {
          return !_(a).isUndefined();
        }, thisArg);
      } else {
        result = {};

        _(_(collection).keys()).each(function (key) {
          if (!_(collection[key]).isUndefined()) result[key] = collection[key];
        });

        return result;
      }
    }
  });

}());
