(function() {
  "use strict";

  Snake.Model = _.extend(Snake.Model || {}, {
    Collection: Backbone.Collection.extend({
      pendingFetches: 0,
      checkReady: function() {
        if (this.pendingFetches === 0) {
          this.trigger("ready", this);
        }
      },
      initialize: function(models, options) {
        this.options = _.defaults(options || {}, {});
      },
      fetch: function() {
        var result, args;

        args = Array.prototype.slice.call(arguments, 0);
        if (args.length === 0) args = [{}];

        args[0].success =
            _(args[0].success || Function()).wrapAppend(function() {
          // Add all children to the pendingFetches
          this.pendingFetches += this.length;
          this.checkReady();

          _(this.models).each(function(model) {
            // Wait for the child model to be ready
            this.listenTo(model, "ready", function(readyModel) {
              if (model !== readyModel) return;
              this.stopListening(model);
              this.pendingFetches--;
              this.checkReady();
            }.bind(this));

            // Enforce the check
            model.checkReady();
          }.bind(this));
        }.bind(this));

        // Fetch myself
        result = Backbone.Collection.prototype.fetch.apply(this, args);

        return result;
      }
    })
  });
}());
