(function() {
  "use strict";

  Snake.Model = _.extend(Snake.Model || {}, {
    /**
     * Model for the whole page
     * @class Snake.Model.Page
     */
    Page: Snake.Model.ModelBase.extend({
      initialize: function(attributes, options) {
        options = options || {};
        this.pages = options.pages || {};
      },
      /**
       * Changes the current page and refersh its data.
       * @memberof Snake.Model.Page#
       * @param {String} page path of the new page to load.
       */
      changePage: function(page) {
        this.set("page", page);

        // http://i.qkme.me/3u6kde.jpg
        Snake.IO.Cache.flush();

        // Take care of updating the content
        this.pages[page].fetch();
      },
      /**
       * Adds a new page to the collection.
       * This method exists only for coherency with
       * Snake.View.Page.
       * @memberof Snake.Model.Page#
       * @param {String} page path of the new page.
       * @param {Snake.Model.ModelBase} model model associated to the
       * new page.
       */
      addPage: function(page, model) {
        this.pages[page] = model;
      },
      defaults: {
        page: "profile"
      }
    })
  });
}());
