(function() {
  "use strict";

  var socket;

  function emit(command, payload) {
    return new Promise(function(resolve) {
      Snake.Perf.TrafficCounter.stat("sent", command, payload);

      socket.emit(command, payload, function(response) {
        resolve(response);
      });
    });
  }

  Snake.Network = {
    init: function () {
      socket = io.connect(Snake.Config.Network.ServerAddress);

      socket.on("connect", function() {
        // TODO implement me
        Snake.Logging.log("network", "Connection established");
      });

      socket.on("disconnect", function() {
        // TODO implement me
        Snake.Logging.error("network", "Connection lost");
      });
    },
    read: function (payload) {
      return emit("read", payload);
    },
    create: function (payload) {
      return emit("create", payload);
    },
    update: function (payload) {
      return emit("update", payload);
    },
    reset: function (payload) {
      return emit("reset", payload);
    }
  };
}());
