(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    CompactUser: Snake.View.ViewBase.extend({
      initialize: function(options) {
        this.renderOn([this.model, this.model.actualProfile]);
      },
      render: function() {
        var newUser, directives;
        directives = {
          user: {
            text: function() {
              var profile = this.actualProfile;
              return profile.name + " " + profile.surname;
            },
            href: function() {
              return "#profile/" + this.actualProfile.id;
            }
          }
        };
        newUser = Snake.instanceTemplate("compact-user",
            this.model.attributeTree(), "", directives);
        this.$el.replaceWith(newUser);
        this.setElement(newUser[0]);
        return this;
      }
    }),
    CompactGroup: Snake.View.ViewBase.extend({
      initialize: function() {
        this.listenTo(this.model, "change", this.render);
      },
      render: function() {
        var newGroup, directives;

        directives = {
          group: {
            text: function() {
              return this.name;
            },
            href: function() {
              return "#group/" + this.id;
            }
          }
        };

        newGroup = Snake.instanceTemplate("compact-group",
            this.model.attributeTree(), "", directives);

        this.$el.replaceWith(newGroup);
        this.setElement(newGroup[0]);

        return this;
      }
    })

  });

}());
