(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    ListProfiles: Snake.View.TriggerView.extend({
      initialize: function(options) {
        this.template = options.template || "compact-profile";

        this.renderOn([this.model, this.model.actualProfile]);
      },
      render: function() {
        var newUser, directives;

        directives = {
          profile: {
            text: function() {
              return this.name + " " + this.surname;
            }
          }
        };

        newUser = Snake.instanceTemplate(this.template,
            this.model.attributeTree(), this.el.id, directives);

        this.$el.replaceWith(newUser);
        this.setElement(newUser[0]);

        return this;
      }
    }),
    ListUsers: Snake.View.TriggerView.extend({
      initialize: function(options) {
        this.template = options.template || "compact-user";

        this.renderOn([this.model, this.model.actualProfile]);
      },
      render: function() {
        var newUser, directives;

        directives = {
          user: {
            text: function() {
              var profile = this.actualProfile;
              return profile.name + " " + profile.surname;
            }
          }
        };

        newUser = Snake.instanceTemplate(this.template,
            this.model.attributeTree(), this.el.id, directives);

        this.$el.replaceWith(newUser);
        this.setElement(newUser[0]);

        return this;
      }
    }),
    ListGroups: Snake.View.TriggerView.extend({
      initialize: function(options) {
        this.template = options.template || "compact-group";

        this.renderOn([this.model]);
      },
      render: function() {
        var newUser, directives;

        directives = {
          group: {
            text: function() {
              return this.name;
            }
          }
        };

        newUser = Snake.instanceTemplate(this.template,
            this.model.attributeTree(), this.el.id, directives);

        this.$el.replaceWith(newUser);
        this.setElement(newUser[0]);

        return this;
      }
    })

  });
}());
