(function() {
  "use strict";

  var Model = Snake.Model;

  Snake.View = _.extend(Snake.View || {}, {
    /**
     * Manages the login form.
     * @class Snake.View.Login
     */
    Login: Snake.View.ViewBase.extend({
      events: {
        "submit": "submitLogin"
      },
      submitLogin: function(event) {
        event.preventDefault();

        // Puts submitted data into a dictionary
        var data = _(this.$el.serializeArray()).reduce(function(acc, field) {
          acc[field.name] = field.value;
          return acc;
        }, {});

        Model.SessionUser.login(data.username, data.password).then(function() {
          Snake.Logging.debug("debug", "user logged in");
          // TODO user logged in
        }.bind(this)).then(function () {
          // Wait to have all the requested data available, i.e.
          // no pending reads
          // this.listenToOnce(Snake.sessionUser, "ready", function() {
            this.trigger("logged");
          // }, this);
        }.bind(this));
      },
      render: function() {
        this.alertError = this.$el.find("#loginFailed");

        return this;
      }
    })
  });
}());
