(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    /**
     *
     * @class Snake.View.ManageFriends
     */
    ManageFriends: Snake.View.ViewBase.extend({
      nestedViews: ["friends"],
      initialize: function(options) {
        this.friends = new Snake.View.UpdatingCollection({
          collection: this.model.friends,
          childViewConstructor: Snake.View.ListUsers,
          childViewOptions: {template: "list-friends"}
        });

        var friends = this.model.friends;
        friends.bind("item:remove", this.remove, this);

        // XXX this is awful
        friends.bind("item:info", function(args) {
          var friendsModels = this.friends.collection.models;
          var friendProfileId = _.findByField(friendsModels, args.id).actualProfile.id;
          window.location.hash = "#profile/" + friendProfileId;
        }, this);
      },
      remove: function(args) {
        var id = args.id;

        Snake.sessionUser.unfriend(id).then(function() {
          this.showAlertSuccess("Friend successfully deleted");
        }.bind(this)).catch(function() {
          this.showAlertError("There was an error, try again later");
        }.bind(this));
      },
      render: function() {
        var newManageFriends;

        newManageFriends = Snake.instanceTemplate("manage-friends",
            this.model.attributeTree(), this.el.id);

        this.renderAllNestedViews(newManageFriends);

        this.$el.replaceWith(newManageFriends);
        this.setElement(newManageFriends[0]);

        this.alertSuccess = this.$el.find("#manageFriendsSuccess");
        this.alertError = this.$el.find("#manageFriendsError");

        this.newGroupForm = this.$el.find("#newFriendForm");
        this.addGroupButton = this.$el.find("#add-friend");

        this.trigger("title", this.title());

        return this;
      },
      title: function() {
        return "Manage your friends";
      }
    })
  });
}());
