(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    /**
     * View for a single message.
     * @class Snake.View.Message
     */
    Message: Snake.View.ViewBase.extend({
      initialize: function() {
        this.renderOn([this.model, this.model.sender.actualProfile]);

        if (!_(this.model.recipient).isUndefined()) {
          this.renderOn([this.model.recipient.actualProfile]);
        }
      },
      render: function() {
        var attributes, directives, newPost;

        // TODO: can we factorize this so we don't have to convert
        // non-trivial data types each time in the view, but let it
        // handl to Snake.instanceTemplate?
        attributes = this.model.attributeTree();
        if (this.model.has("date")) {
          attributes.date = Snake.formatDate(attributes.date);
        }

        // Simplify
        directives = {};
        directives.sender = {
          text: function() {
            var profile = this.sender.actualProfile;
            return profile.name + " " + profile.surname;
          },
          href: function() {
            return "#profile/" + this.sender.actualProfile.id;
          }
        };
        directives.recipient = {
          text: function() {
            var profile = this.recipient.actualProfile;
            return profile.name + " " + profile.surname;
          },
          href: function() {
            return "#profile/" + this.recipient.actualProfile.id;
          }
        };

        newPost = Snake.instanceTemplate("message", attributes, "",
            directives);

        this.$el.replaceWith(newPost);
        this.setElement(newPost[0]);

        return this;
      }
    })
  });
}());
