(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    /**
     * View for the user's private messages.
     * @class Snake.View.Messages
     */
    Messages: Snake.View.ViewBase.extend({
      nestedViews: ["messages", "editor"],
      initialize: function(options) {
        this.messages = new Snake.View.UpdatingCollection({
          collection: this.model.messages,
          childViewConstructor: Snake.View.Message
        });

        this.editor = new Snake.View.MessageEditor({
          recipient: this.model.id,
          collection: this.model.messages,
          message: _(this.model.options.messages).clone()
        });

        this.renderOn([this.model, this.model.actualProfile,
          this.model.messages]);
      },
      render: function() {
        // Create a new instance the template
        var newMessages;

        newMessages = Snake.instanceTemplate("messages",
            this.model.attributeTree(), this.el.id);

        this.renderAllNestedViews(newMessages);

        this.$el.replaceWith(newMessages);
        this.setElement(newMessages[0]);

        this.trigger("title", this.title());

        return this;
      },
      title: function() {
        var profile = this.model.actualProfile;
        return "Messages with " + profile.get("name") + " " +
            profile.get("surname");
      }
    })
  });
}());
