(function() {
  "use strict";

  Snake.View = _.extend(Snake.View || {}, {
    /**
     * View to manage the registration form.
     * @class Snake.View.Register
     */
    Register: Snake.View.ViewBase.extend({
      events: {
        "submit": "submitRegister"
      },
      submitRegister: function(event) {
        event.preventDefault();

        // Puts submitted data into a dictionary
        var data = _(this.$el.serializeArray()).reduce(function(acc, field) {
          acc[field.name] = field.value;
          return acc;
        }, {});

        Snake.Model.SessionUser.register(data.username,
          data.password).then(function()
        {
          Snake.Logging.debug("debug", "user registered");
          this.showAlertSuccess("Registration successful, now you can now log in.");
        }.bind(this)).catch(function() {
          Snake.Logging.debug("debug", "registration failed");
          this.showAlertError("Registration failed");
        }.bind(this));
      },
      render: function() {
        this.alertSuccess = this.$el.find("#registrationSuccessful");
        this.alertError = this.$el.find("#registrationFailed");

        return this;
      }
    })
  });
}());
